//+------------------------------------------------------------------+
//|                                                        cross.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DodgerBlue
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_level1 -85
#property indicator_level2 -15
#property indicator_levelcolor Gold

//-------   --------------------------------------

//-------    -------------------------------
extern string NameMain1    = "GBPJPY"; //    4
extern color       Col1    = DodgerBlue;
extern string NameMain2    = "GBPUSD"; //    5
extern color       Col2    = Lime;
extern string NameMain3    = "USDJPY"; //    6
extern color       Col3    = Red;
extern int    t3_period   = 8;
extern double b           = 0.7;
extern int    per         = 14;

extern int    mBar        = 300;

double e1,e2,e3,e4,e5,e6,c1,c2,c3,c4,n,w1,w2,b2,b3,t3,wpr,
       qe1,qe2,qe3,qe4,qe5,qe6,qw1,qw2,qt3,qwpr,
       je1,je2,je3,je4,je5,je6,jw1,jw2,jt3,jwpr;
int    i;
bool ft = true;
//-------   ------------------------------------------
double buf0[], buf1[], buf2[]; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  SetIndexBuffer(0, buf0);
  SetIndexStyle (0, DRAW_LINE, STYLE_SOLID, 2,Col1);
  SetIndexBuffer(1, buf1);
  SetIndexStyle (1, DRAW_LINE, STYLE_SOLID, 2,Col2);
  SetIndexBuffer(2, buf2);
  SetIndexStyle (2, DRAW_LINE, STYLE_SOLID, 2,Col3);
  IndicatorShortName("cross");
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
   ObjectsDeleteAll(0,OBJ_LABEL);
   ObjectDelete("1para"); 
   ObjectDelete("2para"); 
   ObjectDelete("3para");
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  if(ft) 
  { 
   b2=b*b; 
   b3=b2*b; 
   c1=-b3; 
   c2=(3*(b2+b3)); 
   c3=-3*(2*b2+b+b3); 
   c4=(1+3*b+b3+3*b2); 
   n=t3_period;
   
   if(n<1)
   n=1;  n=1+0.5*(n-1);  
   w1=2/(n+1); w2=1-w1; 
   qw1=2/(n+1); qw2=1-w1; 
   jw1=2/(n+1); jw2=1-w1;
   
   ft=false; 
   }
  
  for(i=Bars-1; i>=0; i--) 
   { 
   buf0[i]=0; 
   buf1[i]=0; 
   buf2[i]=0;
   }
  for(i=mBar; i>=0; i--) 
  {
     wpr=iWPR(NameMain1, 0, per, i);
    qwpr=iWPR(NameMain2, 0, per, i);
    jwpr=iWPR(NameMain3, 0, per, i);
   
   e1=w1*wpr+w2*e1;
   e2=w1*e1+w2*e2; 
   e3=w1*e2+w2*e3; 
   e4=w1*e3+w2*e4; 
   e5=w1*e4+w2*e5; 
   e6=w1*e5+w2*e6;
   
   t3=c1*e6+c2*e5+c3*e4+c4*e3; 
   
   qe1=qw1*qwpr+qw2*qe1; 
   qe2=qw1*qe1+qw2*qe2; 
   qe3=qw1*qe2+qw2*qe3; 
   qe4=qw1*qe3+qw2*qe4;
   qe5=qw1*qe4+qw2*qe5; 
   qe6=qw1*qe5+qw2*qe6; 
   
   qt3=c1*qe6+c2*qe5+c3*qe4+c4*qe3;   
   
   je1=jw1*jwpr+jw2*je1; 
   je2=jw1*je1+jw2*je2; 
   je3=jw1*je2+jw2*je3; 
   je4=jw1*je3+jw2*je4;
   je5=jw1*je4+jw2*je5; 
   je6=jw1*je5+jw2*je6; 
   
   jt3=c1*je6+c2*je5+c3*je4+c4*je3;    
    
    buf0[i]=t3;
    buf1[i]=qt3;
    buf2[i]=jt3;
  }
 string  Pa1=DoubleToStr(buf0[0], 2);
 string  Pa2=DoubleToStr(buf1[0], 2);  
 string  Pa3=DoubleToStr(buf2[0], 2);
    ObjectCreate("1para", OBJ_LABEL, WindowFind("cross"), 0, 0);
        ObjectSet("1para", OBJPROP_CORNER, 0);
        ObjectSet("1para", OBJPROP_XDISTANCE, 935);
        ObjectSet("1para", OBJPROP_YDISTANCE, 45);
    if(buf0[0]>buf0[1])
        ObjectSetText("1para",NameMain1 +" " +Pa1 +" UP",8, "Verdana", Col1);
    else
        ObjectSetText("1para",NameMain1 +" " +Pa1 +" DN",8, "Verdana", Col1);
        
    ObjectCreate("2para", OBJ_LABEL, WindowFind("cross"), 0, 0);
        ObjectSet("2para", OBJPROP_CORNER, 0);
        ObjectSet("2para", OBJPROP_XDISTANCE, 935);
        ObjectSet("2para", OBJPROP_YDISTANCE, 57);
    if(buf1[0]>buf1[1])
        ObjectSetText("2para",NameMain2 +" " +Pa2 +" UP",8, "Verdana", Col2);
    else
        ObjectSetText("2para",NameMain2 +" " +Pa2 +" DN",8, "Verdana", Col2);
            
    ObjectCreate("3para", OBJ_LABEL, WindowFind("cross"), 0, 0);
        ObjectSet("3para", OBJPROP_CORNER, 0);
        ObjectSet("3para", OBJPROP_XDISTANCE, 935);
        ObjectSet("3para", OBJPROP_YDISTANCE, 69);
    if(buf2[0]>buf2[1])
        ObjectSetText("3para",NameMain3 +" " +Pa3 +" UP",8, "Verdana", Col3);
    else
        ObjectSetText("3para",NameMain3 +" " +Pa3 +" DN",8, "Verdana", Col3);            
}      
//+------------------------------------------------------------------+

